// Fill out your copyright notice in the Description page of Project Settings.


#include "LandingZone.h"

#include "EndlessVendetta/EndlessVendettaCharacter.h"
#include "Kismet/GameplayStatics.h"

// Sets default values
ALandingZone::ALandingZone()
{
 	// Set this actor to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = true;

}

void ALandingZone::UpdateAllLandingZones(bool Landing)
{
	TArray<AActor*> AllLandingZones;
	UGameplayStatics::GetAllActorsOfClass(GetWorld(), ALandingZone::StaticClass(), AllLandingZones);
	for (auto LZ_Actor : AllLandingZones)
	{
		ALandingZone* LZ = Cast<ALandingZone>(LZ_Actor);
		Landing ? LZ->HideWaypoint() : LZ->ShowWaypoint();
	}
}

void ALandingZone::Interact()
{
	Takeoff();
}

void ALandingZone::InteractPrompt()
{
	
}

void ALandingZone::Land()
{
	AEndlessVendettaCharacter* PlayerChar = Cast<AEndlessVendettaCharacter>(GetWorld()->GetFirstPlayerController()->GetPawn());
	if (!IsValid(PlayerChar)) return;
	UpdateAllLandingZones(true);
	PlayerChar->ExitShip(LZ_ExitTransform);
}

void ALandingZone::Takeoff()
{
	AEndlessVendettaCharacter* PlayerChar = Cast<AEndlessVendettaCharacter>(GetWorld()->GetFirstPlayerController()->GetPawn());
	if (!IsValid(PlayerChar)) return;
	UpdateAllLandingZones(false);
	PlayerChar->EnterShip(LZ_TakeoffTransform);
}

